# Git Large File Storage How-To

<img src="logo.svg" width="150px" />

*How to use Git LFS on JLU GitLab (and if this is a good idea)*

__NOTE: This project is work in progress!__

## Initial ideas for this project

- Explain/discuss/elaborate if LFS on JLU GitLab is the best choice for your data/project.
    - Contrast especially with [JLUdata](https://jlupub.ub.uni-giessen.de/handle/jlupub/1).
- Provide simple, practical examples what LFS can offer.
    - Tight integration of some data and analysis code.
    - 1st idea: Python code to generate some random data, and plot them in a Jupyter notebook.
    - Maybe add more examples in other languages, or different data (audio, video, images)?
- Anyone is welcome to contribute, with these guidelines:
    - All data, code and text must be self-authored and [licensed as CC0](LICENSE.md), or the material must be properly cited and licensed openly.
    - This project is publicly available to anyone.

## Practical steps how to use LFS (UNFINISHED)
Assumptions:
- You have Git installed on your machine and you know the basics how to use it.
  (If you don't, [here](https://git-scm.com/) is a good point to start).
- You have a project on JLU GitLab, including a Git repository, of which you have a clone on your local machine.
- You can type git commands into a terminal.
  Below, terminal commands are indicated with `a different font, like this`.

1. On your machine, install the Git LFS extension ([here](https://git-lfs.github.com/) are some instructions).
2. In your local repository clone, configure which types of files should be tracked by LFS.
    - For example, to let LFS keep track of HDF files, you can type: `git lfs track "*.hdf"`.
    - This will create (or change) the Git configuration file [`.gitattributes`](.gitattributes).
      You should track this configuration change in Git, e.g. by the usual Git commands `git add .gitattributes` and `git commit -m "start tracking HDF files with LFS"`.
      *Note that because the file name `.gitattributes` starts with a dot, it may be hidden from view (on UNIX derivatives, use `ls -a` to see it).*

## Useful links
- https://git-lfs.github.com/
- https://docs.gitlab.com/ce/topics/git/lfs/
